using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml.Serialization;

namespace dir2xml
{
    public partial class dir2xml : Form
    {

        private string version = "0.1";
        private string dirPath; // ĎfBNg
        private string fileName; // oXMLt@C
        private string appName; // ̃AvP[V̖̂O
        private ArrayList fileList;
        XmlSerializer xmlSerializer;

        public dir2xml()
        {
            InitializeComponent();

            this.Text += " ver."+version;

            fileList = new ArrayList();
            xmlSerializer = new XmlSerializer(typeof(ArrayList));

            appName = "dir2xml.exe";
            dirPath = Application.StartupPath;
            fileName = "dir2xml.xml";
            fileSystemWatcher.Path = dirPath;
            trace("start: " + dirPath);

            reloadFileList(dirPath); // Ƃ肠[h

        }

        #region method
        /// <summary>
        /// eLXg{bNXɕ\
        /// </summary>
        /// <param name="str"></param>
        public void trace(string str)
        {
            textBox1.Text = str + "\r\n" + textBox1.Text;
            Console.WriteLine(str);
        }

        /// <summary>
        /// t@C̈ꗗ擾
        /// </summary>
        /// <param name="dirPath">fBNgpX</param>
        public void reloadFileList(string dirPath)
        {
            DirectoryInfo dirInfo = new DirectoryInfo(dirPath);
            FileInfo[] fileListBuf = dirInfo.GetFiles();
            this.fileList.Clear();
            foreach (FileInfo file in fileListBuf)
            {
                if (file.ToString() != appName && file.ToString() != fileName) // dir2xml.exe͒ǉȂ
                {
                    this.fileList.Add(file.ToString());
                    trace(file.ToString());
                }
            }

            printFileList(this.fileName);
        }

        /// <summary>
        /// fileListxmlŕۑ
        /// reloadFileListĂ1bɌĂ΂悤ɂ悤
        /// </summary>
        /// <param name="fileName">t@C</param>
        public void printFileList(string fileName)
        {
            FileStream fs = new FileStream(fileName, FileMode.Create); // ㏑[h
            xmlSerializer.Serialize(fs, this.fileList);
            fs.Close();
        }
        #endregion

        #region event
        /// <summary>
        /// t@CύXꂽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void fileSystemWatcher_Changed(object sender, System.IO.FileSystemEventArgs e)
        {
            trace("changed: "+e.FullPath);
            if(e.Name != fileName) reloadFileList(dirPath);
        }

        /// <summary>
        /// t@Cꂽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void fileSystemWatcher_Created(object sender, System.IO.FileSystemEventArgs e)
        {
            trace("created: " + e.FullPath);
            if(e.Name != fileName) reloadFileList(dirPath);
        }

        /// <summary>
        /// t@C폜ꂽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void fileSystemWatcher_Deleted(object sender, System.IO.FileSystemEventArgs e)
        {
            trace("deleted: " + e.FullPath);
            if(e.Name != fileName) reloadFileList(dirPath);
        }

        /// <summary>
        /// t@CύXꂽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void fileSystemWatcher_Renamed(object sender, System.IO.RenamedEventArgs e)
        {
            trace("renamed: " + e.FullPath);
            if(e.Name != fileName) reloadFileList(dirPath);
        }
#endregion

    }
}